package org.zipcoder.store;

import java.util.*;

public class MyHashMap implements MyMap{
    // final field that doesn't change for any object
    private static final int BUCKET_SIZE = 15;

    // instance field that can only be set once. It is different for every Object
    private final List<Entry>[] entries;

    public MyHashMap(){
        entries = new List[BUCKET_SIZE];

        for(int i = 0; i < BUCKET_SIZE; i++) {
            entries[i] = new ArrayList<>();
        }
    }

    @Override
    public int size() {
        int size = 0;
        for(List<Entry> lst: entries){
            size+= lst.size();

        }
        return size;
    }

    @Override
    public boolean isEmptry() {
        if(size() == 0){
            return true;
        }
        else{
            return false;
        }
    }

    @Override
    public Cart get(User key) {
        Cart c = null;
        List<Entry> entryList = entries[bucketIndex(key)];
        for(Entry e: entryList){
            if(e.getKey().equals(key)){
               c = e.getValue();
            }

        }
        return c;
    }

    @Override
    public void put(User key, Cart value) {
        entries[bucketIndex(key)].add(new Entry(key,value));
    }

    @Override
    public List<User> getKeys() {
        List<User> u = new ArrayList<>();

        for(List<Entry> entryList : entries){
            for(Entry e : entryList){
                u.add(e.getKey());
            }

        }
        return u;
    }

    @Override
    public List<Cart> getValues() {
        List<Cart> c = new ArrayList<>();
        for(List<Entry> entryList : entries){
            for(Entry e : entryList){
                c.add(e.getValue());
            }
        }
        return c;
    }

    @Override
    public Cart remove(User key) {
        return null;
    }

    private int bucketIndex(User key){
        return Math.abs(key.hashCode()) % entries.length;
    }
}
